Subject: Re: [PATCH v2 net] net: Always untag vlan-tagged traffic on input.

From: Nicolas Dichtel <[email-masked]>
Date: Mon, 29 Sep 2014 15:46:55 +0200

Le 29/09/2014 15:05, Jiri Pirko a écrit :
> Mon, Sep 29, 2014 at 02:44:57PM CEST, [email-masked] wrote:
>> Le 08/08/2014 20:42, Vladislav Yasevich a écrit :
>> [snip]
>>>
>>> The patch attempt to fix this another way.  It moves the vlan header
>>> stipping code out of the vlan module and always builds it into the
>>> kernel network core.  This way, even if vlan is not supported on
>>> a virtualizatoin host, the virtual machines running on top of such
>>> host will still work with VLANs enabled.
>> After this patch (0d5501c1c828 ("net: Always untag vlan-tagged traffic on
>> input.")), tcpdump will not be able to display the VLAN header on input path.
>> Is this really intended?
>
> I assume you are talking about the case when CONFIG_VLAN_8021Q is "n"
> right? Because if it is "m" of "y" I see no change in the code.
Right.

>
> In case of CONFIG_VLAN_8021Q is "n" the only change is that for
> non-accelerated path, skb->vlan_tci is set and vlan header is stripped.
> This makes the path same to accelerated path.
>
> tcpdump should be able to cope with skb->vlan_tci
My fault, I've tested with a quite old tcpdump version, with a recent one it
works perfectly!

Thank you,
Nicolas